lists.openwall.net   lists  /  announce  owl-users  owl-dev  john-users  john-dev  passwdqc-users  yescrypt  popa3d-users  /  oss-security  kernel-hardening  musl  sabotage  tlsify  passwords  /  crypt-dev  xvendor  /  Bugtraq  Full-Disclosure  linux-kernel  linux-netdev  linux-ext4  linux-hardening  linux-cve-announce  PHC 
Open Source and information security mailing list archives
 
Hash Suite: Windows password security audit tool. GUI, reports in PDF.
[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Date:   Mon, 24 Oct 2022 08:33:18 -0300
From:   Arnaldo Carvalho de Melo <acme@...nel.org>
To:     Ian Rogers <irogers@...gle.com>
Cc:     Namhyung Kim <namhyung@...nel.org>, Jiri Olsa <jolsa@...nel.org>,
        Ingo Molnar <mingo@...nel.org>,
        Peter Zijlstra <peterz@...radead.org>,
        LKML <linux-kernel@...r.kernel.org>,
        Adrian Hunter <adrian.hunter@...el.com>,
        linux-perf-users@...r.kernel.org
Subject: Re: [PATCH 3/8] perf test: Use a test program in perf record tests

Em Thu, Oct 20, 2022 at 04:52:14PM -0700, Ian Rogers escreveu:
> On Thu, Oct 20, 2022 at 10:26 AM Namhyung Kim <namhyung@...nel.org> wrote:

> > If the system has cc it could build a test program with two threads
> > and then use it for more detailed testing.  Also it accepts an option
> > to run a thread forever to ensure multi-thread runs.
> >
> > If cc is not found, it falls back to use the default value 'true'.
> >
> > Signed-off-by: Namhyung Kim <namhyung@...nel.org>
> 
> Acked-by: Ian Rogers <irogers@...gle.com>
> 
> I wonder if these utilities should just be built into perf to avoid
> the cc dependency. Perhaps we can have a hidden option built into perf
> test.

Agreed, not depending on a compiler makes 'perf test' usable in more
systems, particularly production ones where we may want to check if perf
is passing all tests applicable to that system.

- Arnaldo
 
> Thanks,
> Ian
> 
> > ---
> >  tools/perf/tests/shell/record.sh | 64 ++++++++++++++++++++++++++++++--
> >  1 file changed, 60 insertions(+), 4 deletions(-)
> >
> > diff --git a/tools/perf/tests/shell/record.sh b/tools/perf/tests/shell/record.sh
> > index 464071462809..952981481239 100755
> > --- a/tools/perf/tests/shell/record.sh
> > +++ b/tools/perf/tests/shell/record.sh
> > @@ -6,10 +6,17 @@ set -e
> >
> >  err=0
> >  perfdata=$(mktemp /tmp/__perf_test.perf.data.XXXXX)
> > +testprog=$(mktemp /tmp/__perf_test.prog.XXXXXX)
> > +testsym="test_loop"
> >
> >  cleanup() {
> >    rm -f "${perfdata}"
> >    rm -f "${perfdata}".old
> > +
> > +  if [ "${testprog}" != "true" ]; then
> > +    rm -f "${testprog}"
> > +  fi
> > +
> >    trap - EXIT TERM INT
> >  }
> >
> > @@ -19,9 +26,56 @@ trap_cleanup() {
> >  }
> >  trap trap_cleanup EXIT TERM INT
> >
> > +build_test_program() {
> > +  if ! [ -x "$(command -v cc)" ]; then
> > +    # No CC found. Fall back to 'true'
> > +    testprog=true
> > +    testsym=true
> > +    return
> > +  fi
> > +
> > +  echo "Build a test program"
> > +  cat <<EOF | cc -o ${testprog} -xc - -pthread
> > +#include <stdio.h>
> > +#include <stdlib.h>
> > +#include <pthread.h>
> > +
> > +void test_loop(void) {
> > +  volatile int count = 1000000;
> > +
> > +  while (count--)
> > +    continue;
> > +}
> > +
> > +void *thfunc(void *arg) {
> > +  int forever = *(int *)arg;
> > +
> > +  do {
> > +    test_loop();
> > +  } while (forever);
> > +
> > +  return NULL;
> > +}
> > +
> > +int main(int argc, char *argv[]) {
> > +  pthread_t th;
> > +  int forever = 0;
> > +
> > +  if (argc > 1)
> > +    forever = atoi(argv[1]);
> > +
> > +  pthread_create(&th, NULL, thfunc, &forever);
> > +  test_loop();
> > +  pthread_join(th, NULL);
> > +
> > +  return 0;
> > +}
> > +EOF
> > +}
> > +
> >  test_per_thread() {
> >    echo "Basic --per-thread mode test"
> > -  if ! perf record -o /dev/null --quiet true 2> /dev/null
> > +  if ! perf record -o /dev/null --quiet ${testprog} 2> /dev/null
> >    then
> >      echo "Per-thread record [Skipped event not supported]"
> >      if [ $err -ne 1 ]
> > @@ -30,13 +84,13 @@ test_per_thread() {
> >      fi
> >      return
> >    fi
> > -  if ! perf record --per-thread -o "${perfdata}" true 2> /dev/null
> > +  if ! perf record --per-thread -o "${perfdata}" ${testprog} 2> /dev/null
> >    then
> >      echo "Per-thread record [Failed record]"
> >      err=1
> >      return
> >    fi
> > -  if ! perf report -i "${perfdata}" -q | grep -q true
> > +  if ! perf report -i "${perfdata}" -q | grep -q "${testsym}"
> >    then
> >      echo "Per-thread record [Failed missing output]"
> >      err=1
> > @@ -62,7 +116,7 @@ test_register_capture() {
> >      return
> >    fi
> >    if ! perf record -o - --intr-regs=di,r8,dx,cx -e br_inst_retired.near_call:p \
> > -    -c 1000 --per-thread true 2> /dev/null \
> > +    -c 1000 --per-thread ${testprog} 2> /dev/null \
> >      | perf script -F ip,sym,iregs -i - 2> /dev/null \
> >      | grep -q "DI:"
> >    then
> > @@ -73,6 +127,8 @@ test_register_capture() {
> >    echo "Register capture test [Success]"
> >  }
> >
> > +build_test_program
> > +
> >  test_per_thread
> >  test_register_capture
> >
> > --
> > 2.38.0.135.g90850a2211-goog
> >

-- 

- Arnaldo

Powered by blists - more mailing lists

Powered by Openwall GNU/*/Linux Powered by OpenVZ